//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DarkGray
#property indicator_color6  Gold
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_level1  0
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern double Period1             =  32;
extern double Period2             =  5;
extern double T3Hot               = 0.5;
extern bool   T3Original          = false;
extern double Period3             = 5;
extern double Period3T3Hot        = 0.4;
extern bool   Period3T3Original   = false;
extern int    Price               = PRICE_CLOSE;
extern bool   alertsOn            = false;
extern bool   alertsOnZeroCross   = true;
extern bool   alertsOnSignalCross = true;
extern bool   alertsOnCurrent     = true;
extern bool   alertsMessage       = true;
extern bool   alertsSound         = false;
extern bool   alertsEmail         = false;


double tsi[];
double tsihuu[];
double tsihud[];
double tsihdd[];
double tsihdu[];
double signal[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,tsihuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,tsihud); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,tsihdd); SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3,tsihdu); SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(4,tsi);
   SetIndexBuffer(5,signal);
   SetIndexBuffer(6,slope);
      IndicatorShortName("Blau ergodic t3 true strength index ("+DoubleToStr(Period1,1)+","+DoubleToStr(Period2,1)+","+DoubleToStr(Period3,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double trend[][2];
#define _signal 0
#define _zeroli 1
 
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);

   //
   //
   //
   //
   //

      for(i=limit, r=Bars-i-1; i >= 0; i--,r++)
      {
         double priceDiff = iMA(NULL,0,1,0,MODE_SMA,Price,i)-iMA(NULL,0,1,0,MODE_SMA,Price,i+1);
         double avg = iT3(iT3(        priceDiff ,Period1,T3Hot,T3Original,i,0),Period2,T3Hot,T3Original,i,1);
         double ava = iT3(iT3(MathAbs(priceDiff),Period1,T3Hot,T3Original,i,2),Period2,T3Hot,T3Original,i,3);
            if (ava != 0)
                  tsi[i] = 100.0*avg/ava;
            else  tsi[i] = 0;                  
            tsihuu[i] = EMPTY_VALUE;
            tsihud[i] = EMPTY_VALUE;
            tsihdd[i] = EMPTY_VALUE;
            tsihdu[i] = EMPTY_VALUE;
            signal[i] = iT3(tsi[i],Period3,Period3T3Hot,Period3T3Original,i,4);

            //
            //
            //
            //
            //
                           
            trend[r][_zeroli] = trend[r-1][_zeroli];
            trend[r][_signal] = trend[r-1][_signal];
            slope[i] = slope[i+1];
               if (tsi[i] > signal[i]) trend[r][_signal] =  1;
               if (tsi[i] < signal[i]) trend[r][_signal] = -1;
               if (tsi[i] > 0)         trend[r][_zeroli] =  1;
               if (tsi[i] < 0)         trend[r][_zeroli] = -1;
               if (tsi[i] > tsi[i+1])  slope[i] =  1;
               if (tsi[i] < tsi[i+1])  slope[i] = -1;
               if (tsi[i]>0)
               if (slope[i]==1)
                     tsihuu[i] = tsi[i];
               else  tsihud[i] = tsi[i];
               if (tsi[i]<0)
               if (slope[i]==1)
                     tsihdu[i] = tsi[i];
               else  tsihdd[i] = tsi[i];
      }
   manageAlerts();
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][30];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-whichBar-1;
      
      //
      //
      //
      //
      //
            
      if (alertsOnZeroCross && trend[whichBar][_zeroli] != trend[whichBar-1][_zeroli])
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (trend[whichBar][_zeroli] ==  1) doAlert(time1,mess1," Blau TSI crossed zero line up");
            if (trend[whichBar][_zeroli] == -1) doAlert(time1,mess1," Blau TSI crossed zero line down");
      }
      if (alertsOnSignalCross && trend[whichBar][_signal] != trend[whichBar-1][_signal])
      {
         static datetime time2 = 0;
         static string   mess2 = "";
            if (trend[whichBar][_signal] ==  1) doAlert(time2,mess2," Blau TSI crossed signal line up");
            if (trend[whichBar][_signal] == -1) doAlert(time2,mess2," Blau TSI crossed signal line down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" Blau ergodic TSI",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

